#include <stdio.h>
#include <stdlib.h>

long long bewegen(int y, int x, int hohe, int breite, char* wald){
	int spalte = 0;
	long long baume = 0;
	for(int i = 0; i < hohe; i = i + y){
		if(wald[i*breite+(spalte%breite)] == '#'){
			baume++;
		}
		spalte = spalte + x;
	}
	return baume;
}

int main(int argc,char** argv){
	int breite,hohe,reihe,spalte;
	hohe = 0;
	breite = 0;
	reihe = 0;
	spalte = 0;
	char c = 0;

	FILE *input;
	if(argc > 1){
		input = fopen(argv[1],"r");
	}else{
		input = fopen("input.txt","r");
	}

	while((c = fgetc(input))!= EOF){
		if(c == '\n'){
			hohe++;
		}
		if(hohe == 0 && c != '\r'){
			breite++;
		}
	}
	
	char *wald;
	wald = malloc(hohe*breite);
	fseek(input,0L,0);
	while((c = fgetc(input)) != EOF){
		if(c != '\n'){
			if(c != '\r'){
				wald[reihe*breite+(spalte%breite)] = c;
				spalte++;
			}
		}else{
			reihe++;
		}
	}
	long long int  ret = 0;
	printf("Breite: %d\tHöhe: %d\n",breite,hohe);
	ret =  bewegen(1,1,hohe,breite,wald) * bewegen(1,3,hohe,breite,wald) * 
		bewegen(1,5,hohe,breite,wald) * bewegen(1,7,hohe,breite,wald) * 
		bewegen(2,1,hohe,breite,wald);
	printf("Bäume Teil 1: %ld\n",bewegen(1,3,hohe,breite,wald));
	printf("Bäume Teil 2: %lld\n",ret);

	free(wald);

	fclose(input);
	return 0;
}
